(**************************************************************************)
(*  ProuveParser: parser frontend for the PROUVÉ language                *)
(*                                                                        *)
(*  Copyright (C) 2004-2009 Ralf Treinen                                  *)
(*                                                                        *)
(*  This library is free software; you can redistribute it and/or         *)
(*  modify it under the terms of the GNU Lesser General Public            *)
(*  License as published by the Free Software Foundation; either          *)
(*  version 2.1 of the License, or (at your option) any later version.    *)
(*                                                                        *)
(*  This library is distributed in the hope that it will be useful,       *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *)
(*  Lesser General Public License for more details.                       *)
(*                                                                        *)
(*  You should have received a copy of the GNU Lesser General Public      *)
(*  License along with this library; if not, write to the Free Software   *)
(*  Foundation, Inc., 59 Temple Place, Suite 330,                         *)
(*  Boston, MA  02111-1307  USA                                           *)
(*                                                                        *)
(*  Ralf Treinen <treinen@pps.jussieu.fr>                                 *)
(*  Laboratoire Preuves, Programmes et Systèmes (PPS),                   *)
(*  Université Paris Diderot, Paris, France                              *)
(*  http://www.pps.jussieu.fr/~treinen                                    *)
(*                                                                        *)
(*  This software was mainly written while the author was with the        *)
(*  Laboratoire Spécification et Vérification (LSV),                    *)
(*  ENS de Cachan, Cachan, France                                         *)
(**************************************************************************)

open Scenarios

(* (check_parameters roledecls mutables sceninst) check for all role   *)
(* invocations in scenario sceninst, whenever a formal parameter of a  *)
(* role is mutable then the corresponding actual parameter is muatble. *)
(* - roledecls is an association list which associates to role names   *)
(*   their parameter declaration.                                      *)
(* - mutables is the list of mutable variabbles.                       *)
(*let rec check_paramters roledecls mutables = function
  | SCall(label,rolename,actuals) ->
      let roledecl = List.assoc rolename roledecls
      in List.map2
	   (function decl exp ->
	      if (fst decl) = Mutable
	      then match exp with
		| Ident(info,varname) ->
		    if info.exp_varkind 
	   roledecl
	   actuals
*)   


let analyse_scenario sign role_decl gl_var_decl sceninst =
  try
    Utils.alldifferent (gather_checkpoints sceninst);
    let sceninst_typed =
      Scenarios_typing.type_scenario sign role_decl gl_var_decl
	(Declarations.unskolemize gl_var_decl) sceninst
    in sceninst_typed
  with
      Utils.Twice cp ->
	raise
	  (Exc_scenario
	     ("the checkpoint \"" ^cp^ "\" occurs multiple times " ^
		"in the scenario"))
    
